diff --git a/app/services/authorizer.rb b/app/services/authorizer.rb
new file mode 100644
index 000000000..aec2a7c1d
--- /dev/null
+++ b/app/services/authorizer.rb
@@ -0,0 +1,136 @@
+class Authorizer
+  attr_accessor :user, :base_collection, :organization_ids, :location_ids
+
+  def initialize(user, options = {})
+
+    @cache = HashWithIndifferentAccess.new { |h, k| h[k] = HashWithIndifferentAccess.new }
+    self.user = user
+    self.base_collection = options.delete(:collection)
+  end
+
+  def can?(permission, subject = nil)
+    if subject.nil?
+      user.permissions.where(:name => permission).present?
+    else
+      return true if user.admin?
+      collection = @cache[subject.class.to_s][permission] ||= find_collection(subject.class, :permission => permission)
+      collection.include?(subject)
+    end
+  end
+
+  def find_collection(resource_class, options = {})
+    permission = options.delete :permission
+
+    base = user.filters.joins(:permissions).where(["#{Permission.table_name}.resource_type = ?", resource_name(resource_class)])
+    all_filters = permission.nil? ? base : base.where(["#{Permission.table_name}.name = ?", permission])
+
+    organization_ids = allowed_organizations(resource_class)
+    location_ids     = allowed_locations(resource_class)
+
+    organizations, locations, values = taxonomy_conditions(organization_ids, location_ids)
+    all_filters = all_filters.joins(taxonomy_join).where(["#{TaxableTaxonomy.table_name}.id IS NULL " +
+                                                              "OR (#{organizations}) " +
+                                                              "OR (#{locations})",
+                                                          *values]).uniq
+
+    all_filters = all_filters.all # load all records, so #empty? does not call extra COUNT(*) query
+    return resource_class.where('1=0') if all_filters.empty?
+
+    unless @base_collection.nil?
+      if @base_collection.empty?
+        return resource_class.where('1=0')
+      else
+        resource_class = resource_class.where(:id => base_ids)
+      end
+    end
+
+    return resource_class.scoped if all_filters.any?(&:unlimited?)
+
+    search_string = build_scoped_search_condition(all_filters.select(&:limited?))
+    resource_class.search_for(search_string)
+  end
+
+  def build_scoped_search_condition(filters)
+    raise ArgumentError if filters.blank?
+
+    strings = filters.map { |f| "(#{f.search_condition.blank? ? '1=1' : f.search_condition})" }
+    strings.join(' OR ')
+  end
+
+  private
+
+  def allowed_organizations(resource_class)
+    allowed_taxonomies(resource_class, 'organization')
+  end
+
+  def allowed_locations(resource_class)
+    allowed_taxonomies(resource_class, 'location')
+  end
+
+  # return array of taxonomies that were used by default scope
+  # if model does not support taxonomies, we return empty array indicating
+  #   we should not filter on taxonomies
+  # otherwise we fetch it from model, if it's empty
+  #   for admin user we return empty array which means don't limit
+  #   for normal user we allow user taxonomies only
+  def allowed_taxonomies(resource_class, type)
+    taxonomy_ids = []
+    if resource_class.respond_to?("used_#{type}_ids")
+      taxonomy_ids = resource_class.send("used_#{type}_ids")
+      if taxonomy_ids.empty? && !User.current.try(:admin?)
+        taxonomy_ids = User.current.try("#{type}_ids")
+      end
+    end
+    taxonomy_ids
+  end
+
+  def taxonomy_join
+    "LEFT JOIN #{TaxableTaxonomy.table_name} ON " +
+        "(#{Filter.table_name}.id = #{TaxableTaxonomy.table_name}.taxable_id AND taxable_type = 'Filter') " +
+        "LEFT JOIN #{Taxonomy.table_name} ON " +
+        "(#{Taxonomy.table_name}.id = #{TaxableTaxonomy.table_name}.taxonomy_id)"
+  end
+
+  def taxonomy_conditions(organization_ids, location_ids)
+    values = []
+
+    organizations = "#{Taxonomy.table_name}.type = ?"
+    values.push 'Organization'
+    unless organization_ids.empty?
+      organizations += " AND #{Taxonomy.table_name}.id IN (?)"
+      values.push organization_ids
+    end
+
+    locations = "#{Taxonomy.table_name}.type = ?"
+    values.push 'Location'
+    unless location_ids.empty?
+      locations += " AND #{Taxonomy.table_name}.id IN (?)"
+      values.push location_ids
+    end
+
+    return [organizations, locations, values]
+  end
+
+  # sometimes we need exceptions however we don't want to just split namespaces
+  def resource_name(klass)
+    return 'Operatingsystem' if klass <= Operatingsystem
+
+    case name = klass.to_s
+      when 'Audited::Adapters::ActiveRecord::Audit'
+        'Audit'
+      when /\AHost::.*\Z/
+        'Host'
+      when /\AForeman::Model::.*\Z/
+        'ComputeResource'
+      else
+        name
+      end
+  end
+
+  def base_ids
+    raise ArgumentError, 'you must set base_collection to get base_ids' if @base_collection.nil?
+
+    @base_ids ||= @base_collection.all? { |i| i.is_a?(Fixnum) } ? @base_collection : @base_collection.map(&:id)
+  end
+
+end
diff --git a/app/services/cache_manager.rb b/app/services/cache_manager.rb
new file mode 100644
index 000000000..2f1509777
--- /dev/null
+++ b/app/services/cache_manager.rb
@@ -0,0 +1,23 @@
+class CacheManager
+  def self.delete_old_permission_cache
+    CachedUsergroupMember.delete_all
+    CachedUserRole.delete_all
+  end
+
+  def self.create_new_permission_cache
+    UsergroupMember.all.map &:save!
+    UserRole.all.map &:save!
+  end
+
+  def self.create_new_filter_cache
+    Filter.all.each &:save!
+  end
+
+  def self.recache!
+    Rails.logger.warn 'Recreating the whole DB cache'
+    delete_old_permission_cache
+    create_new_permission_cache
+    create_new_filter_cache
+    Setting::General[:fix_db_cache] = false
+  end
+end
diff --git a/app/services/dashboard.rb b/app/services/dashboard.rb
index 3ebb4cb27..5bf974822 100644
--- a/app/services/dashboard.rb
+++ b/app/services/dashboard.rb
@@ -13,7 +13,7 @@ class Dashboard
   end
 
   def hosts
-    @hosts ||= Host.my_hosts.search_for(filter)
+    @hosts ||= Host.authorized(:view_hosts, Host).search_for(filter)
   end
 
   private
diff --git a/app/services/foreman/access_permissions.rb b/app/services/foreman/access_permissions.rb
index a52f37448..d9315c5f5 100644
--- a/app/services/foreman/access_permissions.rb
+++ b/app/services/foreman/access_permissions.rb
@@ -2,6 +2,11 @@ require 'foreman/access_control'
 
 # Permissions
 Foreman::AccessControl.map do |map|
+  map.security_block :public do |map|
+    map.permission :user_logout, { :users => [:logout] }, :public => true
+    map.permission :my_account, { :users => [:edit] }, :public => true
+  end
+
   map.security_block :architectures do |map|
     map.permission :view_architectures,
                    :architectures => [:index, :show, :auto_complete_search],
@@ -194,6 +199,17 @@ Foreman::AccessControl.map do |map|
                                                  :"api/v2/override_values" => [:create, :update, :destroy]}
   end
 
+  map.security_block :filters do |map|
+    map.permission :view_filters,    {:filters => [:index, :auto_complete_search],
+                                      :'api/v2/filters' => [:index, :show]}
+    map.permission :create_filters,  {:filters => [:new, :create],
+                                      :'api/v2/filters' => [:create]}
+    map.permission :edit_filters,    {:filters => [:edit, :update], :permissions => [:index],
+                                      :'api/v2/filters' => [:update], :'api/v2/permissions' => [:index, :show]}
+    map.permission :destroy_filters, {:filters => [:destroy],
+                                      :'api/v2/filters' => [:destroy]}
+  end
+
   map.security_block :global_variables do |map|
     map.permission :view_globals,    {:common_parameters => [:index, :show, :auto_complete_search],
                                       :"api/v1/common_parameters" => [:index, :show],
@@ -469,8 +485,19 @@ Foreman::AccessControl.map do |map|
                                             }
   end
 
+  map.security_block :roles do |map|
+    map.permission :view_roles,    {:roles => [:index, :auto_complete_search],
+                                    :'api/v2/roles' => [:index, :show]}
+    map.permission :create_roles,  {:roles => [:new, :create, :clone],
+                                    :'api/v2/roles' => [:create]}
+    map.permission :edit_roles,    {:roles => [:edit, :update],
+                                    :'api/v2/roles' => [:update]}
+    map.permission :destroy_roles, {:roles => [:destroy],
+                                    :'api/v2/roles' => [:destroy]}
+  end
+
   map.security_block :smart_proxies do |map|
-    map.permission :view_smart_proxies,    {:smart_proxies => [:index, :ping],
+    map.permission :view_smart_proxies,    {:smart_proxies => [:index, :ping, :auto_complete_search],
                                           :"api/v1/smart_proxies" => [:index, :show],
                                           :"api/v2/smart_proxies" => [:index, :show]
     }
@@ -546,7 +573,7 @@ Foreman::AccessControl.map do |map|
   end
 
   map.security_block :usergroups do |map|
-    map.permission :view_usergroups,    {:usergroups => [:index, :show],
+    map.permission :view_usergroups,    {:usergroups => [:index, :show, :auto_complete_search],
                                          :"api/v1/usergroups" => [:index, :show],
                                          :"api/v2/usergroups" => [:index, :show]
     }
diff --git a/app/services/foreman/plugin.rb b/app/services/foreman/plugin.rb
index 759794544..e5818fc72 100644
--- a/app/services/foreman/plugin.rb
+++ b/app/services/foreman/plugin.rb
@@ -164,7 +164,13 @@ module Foreman #:nodoc:
     end
 
     # Defines a permission called name for the given controller=>actions
+    # :options can contain :resource_type key which is the string of resource
+    #   class to which this permissions is related, rest of options is passed
+    #   to AccessControl
     def permission(name, hash, options={})
+      resource_type = options.delete(:resource_type)
+      Permission.first rescue return false
+      Permission.find_or_create_by_name_and_resource_type(name, resource_type)
       options.merge!(:security_block => @security_block)
       Foreman::AccessControl.map do |map|
         map.permission name, hash, options
@@ -175,7 +181,8 @@ module Foreman #:nodoc:
     def role(name, permissions)
       Role.transaction do
         role = Role.find_or_create_by_name(name)
-        role.update_attribute :permissions, permissions if role.permissions.empty?
+        Permission.first rescue return false
+        role.add_permissions!(permissions) if role.permissions.empty?
       end
     end
 
diff --git a/app/views/about/index.html.erb b/app/views/about/index.html.erb
index 2bc7cfbc5..74bd6c76f 100644
--- a/app/views/about/index.html.erb
+++ b/app/views/about/index.html.erb
@@ -15,7 +15,7 @@
       </ul>
       <div class="tab-content">
         <div class="tab-pane active" id="smart_proxies">
-          <% if @proxies.empty? %>
+          <% if @smart_proxies.empty? %>
             <p class="ca"><%= _("No smart proxies to show") %></p>
           <% else %>
             <table class="table table-striped">
@@ -24,7 +24,7 @@
                 <th><%= _("Features") %></th>
                 <th><%= _("Status") %></th>
               </tr>
-              <% @proxies.each do |proxy| %>
+              <% @smart_proxies.each do |proxy| %>
                 <tr>
                   <td><%= link_to_if_authorized proxy.name, hash_for_edit_smart_proxy_path(:id => proxy.id) %></td>
                   <td><%=h proxy.features.to_sentence %></td>
diff --git a/app/views/api/v2/filters/base.json.rabl b/app/views/api/v2/filters/base.json.rabl
new file mode 100644
index 000000000..5397cbe54
--- /dev/null
+++ b/app/views/api/v2/filters/base.json.rabl
@@ -0,0 +1,3 @@
+object @filter
+
+attributes :id
diff --git a/app/views/api/v2/filters/create.json.rabl b/app/views/api/v2/filters/create.json.rabl
new file mode 100644
index 000000000..359008c6f
--- /dev/null
+++ b/app/views/api/v2/filters/create.json.rabl
@@ -0,0 +1,3 @@
+object @filter
+
+extends "api/v2/filters/show"
diff --git a/app/views/api/v2/filters/index.json.rabl b/app/views/api/v2/filters/index.json.rabl
new file mode 100644
index 000000000..f33e6bb7d
--- /dev/null
+++ b/app/views/api/v2/filters/index.json.rabl
@@ -0,0 +1,3 @@
+collection @filters
+
+extends "api/v2/filters/main"
diff --git a/app/views/api/v2/filters/main.json.rabl b/app/views/api/v2/filters/main.json.rabl
new file mode 100644
index 000000000..fe8c68f7c
--- /dev/null
+++ b/app/views/api/v2/filters/main.json.rabl
@@ -0,0 +1,5 @@
+object @filter
+
+extends "api/v2/filters/base"
+
+attributes :search, :resource_type, :role_id, :created_at, :updated_at
diff --git a/app/views/api/v2/filters/show.json.rabl b/app/views/api/v2/filters/show.json.rabl
new file mode 100644
index 000000000..0849e7198
--- /dev/null
+++ b/app/views/api/v2/filters/show.json.rabl
@@ -0,0 +1,20 @@
+object @filter
+
+extends "api/v2/filters/main"
+
+child :permissions => :permissions do
+  extends "api/v2/permissions/base"
+end
+
+# TODO: Fix when https://github.com/theforeman/foreman/pull/1208 is merged
+if SETTINGS[:organizations_enabled]
+  child :organizations => :organizations do
+    attributes :id, :name
+  end
+end
+
+if SETTINGS[:locations_enabled]
+  child :locations => :locations do
+    attributes :id, :name
+  end
+end
diff --git a/app/views/api/v2/permissions/base.json.rabl b/app/views/api/v2/permissions/base.json.rabl
new file mode 100644
index 000000000..725904d64
--- /dev/null
+++ b/app/views/api/v2/permissions/base.json.rabl
@@ -0,0 +1,3 @@
+object @permission
+
+attributes :name, :id
\ No newline at end of file
diff --git a/app/views/api/v2/permissions/index.json.rabl b/app/views/api/v2/permissions/index.json.rabl
new file mode 100644
index 000000000..a29ab7095
--- /dev/null
+++ b/app/views/api/v2/permissions/index.json.rabl
@@ -0,0 +1,3 @@
+collection @permissions
+
+extends "api/v2/permissions/main"
\ No newline at end of file
diff --git a/app/views/api/v2/permissions/main.json.rabl b/app/views/api/v2/permissions/main.json.rabl
new file mode 100644
index 000000000..6e4feeebc
--- /dev/null
+++ b/app/views/api/v2/permissions/main.json.rabl
@@ -0,0 +1,3 @@
+object @permission
+
+extends "api/v2/permissions/base"
diff --git a/app/views/api/v2/permissions/show.json.rabl b/app/views/api/v2/permissions/show.json.rabl
new file mode 100644
index 000000000..251b354b3
--- /dev/null
+++ b/app/views/api/v2/permissions/show.json.rabl
@@ -0,0 +1,3 @@
+object @permission
+
+extends "api/v2/permissions/main"
diff --git a/app/views/api/v2/roles/main.json.rabl b/app/views/api/v2/roles/main.json.rabl
index 8b5903678..38b38ffd1 100644
--- a/app/views/api/v2/roles/main.json.rabl
+++ b/app/views/api/v2/roles/main.json.rabl
@@ -2,4 +2,4 @@ object @role
 
 extends "api/v2/roles/base"
 
-attributes :builtin, :permissions, :created_at, :updated_at
+attributes :builtin, :created_at, :updated_at
diff --git a/app/views/api/v2/roles/show.json.rabl b/app/views/api/v2/roles/show.json.rabl
index 5ceec525c..874afd838 100644
--- a/app/views/api/v2/roles/show.json.rabl
+++ b/app/views/api/v2/roles/show.json.rabl
@@ -1,3 +1,7 @@
 object @role
 
 extends "api/v2/roles/main"
+
+child :filters => :filters do
+  extends "api/v2/filters/base"
+end
diff --git a/app/views/architectures/index.html.erb b/app/views/architectures/index.html.erb
index 10ee5b879..c011662a4 100644
--- a/app/views/architectures/index.html.erb
+++ b/app/views/architectures/index.html.erb
@@ -9,10 +9,12 @@
   </tr>
   <% for architecture in @architectures %>
     <tr>
-      <td class='col-md-3'><%= link_to_if_authorized(h(architecture.name), hash_for_edit_architecture_path(:id => architecture)) %></td>
+      <td class='col-md-3'><%= link_to_if_authorized(h(architecture.name),
+                                                     hash_for_edit_architecture_path(:id => architecture).merge(:auth_object => architecture, :authorizer => authorizer)) %></td>
       <td><%=h architecture.operatingsystems.map(&:to_label).to_sentence %></td>
       <td align="right">
-        <%= display_delete_if_authorized hash_for_architecture_path(:id => architecture.name), :confirm => "Delete #{architecture.name}?" %>
+        <%= display_delete_if_authorized hash_for_architecture_path(:id => architecture.name).merge(:auth_object => architecture, :authorizer => authorizer),
+                                         :confirm => "Delete #{architecture.name}?" %>
       </td>
     </tr>
   <% end %>
diff --git a/app/views/audits/show.html.erb b/app/views/audits/show.html.erb
index 478dce3cd..0482e1bb0 100644
--- a/app/views/audits/show.html.erb
+++ b/app/views/audits/show.html.erb
@@ -1,11 +1,11 @@
 <% title "#{@audit.action.camelize} #{audited_type @audit}: #{audit_title @audit}" %>
 
 <%= title_actions link_to_if_authorized(_("Host details"),
-                                        hash_for_host_path(:id => @audit.auditable.to_param),
+                                        hash_for_host_path(:id => @audit.auditable.to_param).merge(:auth_object => @audit.auditable, :auth_action => 'view'),
                                         :title => _("Host details"),
                                         :class => 'btn btn-info') if @audit.auditable_type == 'Host' && @audit.auditable %>
 <%= title_actions link_to 'Back', :back, :class=>'btn btn-default' %>
-<% tmplt =  audit_template?(@audit) %>
+<% tmplt = audit_template?(@audit) %>
 
 <div class="tabbable">
   <ul class="nav nav-tabs">
diff --git a/app/views/autosign/index.html.erb b/app/views/autosign/index.html.erb
index 43559c42f..a6bb556ec 100644
--- a/app/views/autosign/index.html.erb
+++ b/app/views/autosign/index.html.erb
@@ -1,8 +1,7 @@
 <% title _("Autosign entries for %s") % @proxy %>
 
-<% title_actions display_link_if_authorized(_("Certificates"), hash_for_smart_proxy_puppetca_index_path(:smart_proxy_id => @proxy)),
+<% title_actions display_link_if_authorized(_("Certificates"), hash_for_smart_proxy_puppetca_index_path(:smart_proxy_id => @proxy).merge(:auth_object => @proxy, :permission => 'view_smart_proxies_puppetca')),
   autosign_form %>
-
 <table class='table table-bordered table-striped table-condensed'>
   <tr>
     <th><%= _("Name") %></th>
@@ -12,7 +11,7 @@
       <tr>
         <td><%= h cert%> </td>
         <td>
-          <%= action_buttons(display_delete_if_authorized hash_for_smart_proxy_autosign_path(:smart_proxy_id => @proxy, :id => cert), :class => 'delete')%>
+          <%= action_buttons(display_delete_if_authorized hash_for_smart_proxy_autosign_path(:smart_proxy_id => @proxy, :id => cert).merge(:auth_object => @proxy), :class => 'delete')%>
         </td>
       </tr>
   <% end %>
diff --git a/app/views/common_parameters/index.html.erb b/app/views/common_parameters/index.html.erb
index 4d1115011..4304e0ea6 100644
--- a/app/views/common_parameters/index.html.erb
+++ b/app/views/common_parameters/index.html.erb
@@ -10,10 +10,11 @@
   </tr>
   <% for common_parameter in @common_parameters %>
     <tr>
-      <td><%= link_to_if_authorized h(common_parameter), hash_for_edit_common_parameter_path(:id => common_parameter.id)%></td>
+      <td><%= link_to_if_authorized h(common_parameter), hash_for_edit_common_parameter_path(:id => common_parameter.id).merge(:auth_object => common_parameter, :authorizer => authorizer, :permission => 'edit_globals') %></td>
       <td style='overflow-wrap: break-word;'><%= trunc(common_parameter.value,80  ) %></td>
       <td class="ra">
-        <%= display_delete_if_authorized hash_for_common_parameter_path(:id => common_parameter), :confirm => _("Delete %s?") % common_parameter.name %>
+        <%= display_delete_if_authorized hash_for_common_parameter_path(:id => common_parameter).merge(:auth_object => common_parameter, :authorizer => authorizer, :permission => 'destroy_globals'),
+                                         :confirm => _("Delete %s?") % common_parameter.name %>
       </td>
     </tr>
   <% end %>
diff --git a/app/views/compute_profiles/index.html.erb b/app/views/compute_profiles/index.html.erb
index f1c6aafc9..1dd17e2ef 100644
--- a/app/views/compute_profiles/index.html.erb
+++ b/app/views/compute_profiles/index.html.erb
@@ -9,11 +9,11 @@
   </tr>
   <% @compute_profiles.each do |compute_profile| %>
     <tr>
-      <td><%= link_to_if_authorized h(compute_profile.name), hash_for_compute_profile_path(compute_profile)%></td>
+      <td><%= link_to_if_authorized h(compute_profile.name), hash_for_compute_profile_path(compute_profile).merge(:auth_object => compute_profile, :authorizer => authorizer, :auth_action => 'edit') %></td>
       <td><%= action_buttons(
-                display_link_if_authorized(_('Edit'), hash_for_compute_profile_path(compute_profile)),
-                display_link_if_authorized(_('Rename'), hash_for_edit_compute_profile_path(compute_profile)),
-                display_delete_if_authorized(hash_for_compute_profile_path(compute_profile), :confirm => _('Delete %s?') % compute_profile.name))%>
+                display_link_if_authorized(_('Edit'), hash_for_compute_profile_path(compute_profile).merge(:auth_object => compute_profile, :authorizer => authorizer, :auth_action => 'edit')),
+                display_link_if_authorized(_('Rename'), hash_for_edit_compute_profile_path(compute_profile).merge(:auth_object => compute_profile, :authorizer => authorizer)),
+                display_delete_if_authorized(hash_for_compute_profile_path(compute_profile).merge(:auth_object => compute_profile, :authorizer => authorizer), :confirm => _('Delete %s?') % compute_profile.name))%>
       </td>
     </tr>
   <% end %>
diff --git a/app/views/compute_profiles/show.html.erb b/app/views/compute_profiles/show.html.erb
index 9485e2061..c390fd74c 100644
--- a/app/views/compute_profiles/show.html.erb
+++ b/app/views/compute_profiles/show.html.erb
@@ -13,7 +13,7 @@
     <th><%= _("Compute Resource") %></th>
     <th><%= _("VM Attributes (%s)") % @compute_profile.name %></th>
   </tr>
-    <% ComputeResource.my_compute_resources.each do |compute_resource| %>
+    <% ComputeResource.authorized(:view_compute_resources).each do |compute_resource| %>
       <% compute_attribute = ComputeAttribute.where(:compute_profile_id => @compute_profile.id, :compute_resource_id => compute_resource.id).first %>
       <% which_path = if compute_attribute.try(:id)
                         edit_compute_profile_compute_attribute_path(@compute_profile.to_param, compute_attribute.id)
diff --git a/app/views/compute_resources/index.html.erb b/app/views/compute_resources/index.html.erb
index 8cb5a6371..5f83b9e44 100644
--- a/app/views/compute_resources/index.html.erb
+++ b/app/views/compute_resources/index.html.erb
@@ -13,8 +13,8 @@
     <td><%= link_to compute.name, compute %></td>
     <td><%= compute.provider_friendly_name %></td>
     <td>
-      <%= action_buttons(link_to(_('Edit'), edit_compute_resource_path(compute)),
-                         display_delete_if_authorized(hash_for_compute_resource_path(:id => compute), :confirm => _("Delete %s?") % compute.name)) %>
+      <%= action_buttons(link_to_if_authorized(_('Edit'), hash_for_edit_compute_resource_path(compute).merge(:auth_object => compute, :authorizer => authorizer)),
+                         display_delete_if_authorized(hash_for_compute_resource_path(:id => compute).merge(:auth_object => compute, :authorizer => authorizer), :confirm => _("Delete %s?") % compute.name)) %>
     </td>
   </tr>
 <% end %>
diff --git a/app/views/compute_resources/show.html.erb b/app/views/compute_resources/show.html.erb
index fbc8d4800..580f6fa8d 100644
--- a/app/views/compute_resources/show.html.erb
+++ b/app/views/compute_resources/show.html.erb
@@ -1,8 +1,10 @@
 <%= javascript 'compute_resource', 'lookup_keys'%>
 <% title @compute_resource.name %>
 
-<% title_actions display_link_if_authorized(_("Associate VMs"), hash_for_associate_compute_resource_path(:compute_resource_id => @compute_resource), :title=> _("Associate VMs to Foreman hosts"), :method => :put, :class=>"btn btn-default"),
-   link_to(_('Edit'), edit_compute_resource_path(@compute_resource), :class => "btn btn-default")  %>
+<% title_actions display_link_if_authorized(_("Associate VMs"),
+                                            hash_for_associate_compute_resource_path(:compute_resource_id => @compute_resource).merge(:auth_object => @compute_resource, :permission => 'edit_compute_resources'),
+                                            :title => _("Associate VMs to Foreman hosts"), :method => :put, :class=>"btn btn-default"),
+   link_to_if_authorized(_('Edit'), hash_for_edit_compute_resource_path(@compute_resource).merge(:auth_object => @compute_resource), :class => "btn btn-default")  %>
 
 <ul class="nav nav-tabs" data-tabs="tabs">
   <li class="active"><a href="#primary" data-toggle="tab"><%= _("Compute Resource") %></a></li>
diff --git a/app/views/compute_resources_vms/index/_ec2.html.erb b/app/views/compute_resources_vms/index/_ec2.html.erb
index bad97eb26..38f38c75b 100644
--- a/app/views/compute_resources_vms/index/_ec2.html.erb
+++ b/app/views/compute_resources_vms/index/_ec2.html.erb
@@ -10,13 +10,14 @@
   </thead>
   <% @vms.each do |vm| %>
     <tr>
-      <td><%= link_to_if_authorized vm.name, hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity) %></td>
+      <td><%= link_to_if_authorized vm.name, hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity).merge(:auth_object => @compute_resource, :authorizer => authorizer) %></td>
       <td><%= vm.dns %></td>
       <td><%= vm.flavor_id %></td>
       <td> <span <%= vm_power_class(vm.ready?) %>> <%= vm_state(vm) %></span> </td>
       <td>
         <%= unless vm.state == 'terminated' or vm.state == 'pending'
-              action_buttons(vm_power_action(vm), display_delete_if_authorized(hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.id)))
+              action_buttons(vm_power_action(vm, authorizer),
+                             display_delete_if_authorized(hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.id).merge(:auth_object => @compute_resource, :authorizer => authorizer)))
             end
         %>
       </td>
diff --git a/app/views/compute_resources_vms/index/_gce.html.erb b/app/views/compute_resources_vms/index/_gce.html.erb
index b2d68ca39..58f05dc03 100644
--- a/app/views/compute_resources_vms/index/_gce.html.erb
+++ b/app/views/compute_resources_vms/index/_gce.html.erb
@@ -9,11 +9,12 @@
   </thead>
   <% @vms.each do |vm| %>
     <tr>
-      <td><%= link_to_if_authorized vm.name, hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity) %></td>
+      <td><%= link_to_if_authorized vm.name, hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity).merge(:auth_object => @compute_resource, :authorizer => authorizer) %></td>
       <td><%= vm.pretty_machine_type %></td>
       <td><%= vm.state.downcase %></td>
       <td>
-        <%= action_buttons(vm_power_action(vm), display_delete_if_authorized(hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity))) %>
+        <%= action_buttons(vm_power_action(vm, authorizer),
+                           display_delete_if_authorized(hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity).merge(:auth_object => @compute_resource, :authorizer => authorizer))) %>
       </td>
     </tr>
   <% end %>
diff --git a/app/views/compute_resources_vms/index/_libvirt.html.erb b/app/views/compute_resources_vms/index/_libvirt.html.erb
index 307a01b77..287c90a74 100644
--- a/app/views/compute_resources_vms/index/_libvirt.html.erb
+++ b/app/views/compute_resources_vms/index/_libvirt.html.erb
@@ -10,13 +10,13 @@
   </thead>
   <% @vms.each do |vm| %>
     <tr>
-      <td><%= link_to_if_authorized vm.name, hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.uuid) %></td>
+      <td><%= link_to_if_authorized vm.name, hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.uuid).merge(:auth_object => @compute_resource, :authorizer => authorizer) %></td>
       <td><%= vm.cpus %></td>
       <td> <%= number_to_human_size vm.memory_size*1024 %> </td>
       <td> <span <%= vm_power_class(vm.ready?) %>> <%= vm_state(vm) %></span> </td>
       <td>
-        <%= action_buttons(vm_power_action(vm),
-            display_delete_if_authorized(hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.uuid))) %>
+        <%= action_buttons(vm_power_action(vm, authorizer),
+            display_delete_if_authorized(hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.uuid).merge(:auth_object => @compute_resource, :authorizer => authorizer))) %>
       </td>
     </tr>
   <% end %>
diff --git a/app/views/compute_resources_vms/index/_ovirt.html.erb b/app/views/compute_resources_vms/index/_ovirt.html.erb
index 0122e564e..0c5a1931c 100644
--- a/app/views/compute_resources_vms/index/_ovirt.html.erb
+++ b/app/views/compute_resources_vms/index/_ovirt.html.erb
@@ -10,13 +10,13 @@
   </thead>
   <% @vms.each do |vm| %>
     <tr>
-      <td><%= link_to_if_authorized vm.name, hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity) %></td>
+      <td><%= link_to_if_authorized vm.name, hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity).merge(:auth_object => @compute_resource, :authorizer => authorizer) %></td>
       <td><%= vm.cores %></td>
       <td> <%= number_to_human_size vm.memory %> </td>
       <td> <span <%= vm_power_class(vm.ready?) %>> <%= vm_state(vm) %></span> </td>
       <td>
-        <%= action_buttons(vm_power_action(vm),
-                           display_delete_if_authorized(hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.id))) %>
+        <%= action_buttons(vm_power_action(vm, authorizer),
+                           display_delete_if_authorized(hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.id).merge(:auth_object => @compute_resource, :authorizer => authorizer))) %>
       </td>
 
     </tr>
diff --git a/app/views/compute_resources_vms/index/_rackspace.html.erb b/app/views/compute_resources_vms/index/_rackspace.html.erb
index 0b6057df7..25883cefd 100644
--- a/app/views/compute_resources_vms/index/_rackspace.html.erb
+++ b/app/views/compute_resources_vms/index/_rackspace.html.erb
@@ -14,8 +14,8 @@
       <td> <span <%= vm_power_class(vm.ready?) %>> <%= vm_state(vm) %></span> </td>
       <td>
         <%= action_buttons(
-                vm_power_action(vm),
-                display_delete_if_authorized(hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.id))) %>
+                vm_power_action(vm, authorizer),
+                display_delete_if_authorized(hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.id).merge(:auth_object => @compute_resource, :authorizer => authorizer))) %>
       </td>
     </tr>
   <% end %>
